# Change Log
All notable changes to this project will be documented in this file.
This project adheres to [Semantic Versioning](http://semver.org/).

## [Unreleased]

## [0.8.0] - 2016-04-18
### Added
- CHANGELOG to ["make it easier for users and contributors to see precisely what notable changes have been made between each release"](http://keepachangelog.com/). Linked to from README
- LICENSE to be more explicit about what was defined in `package.json`. Linked to from README
- It is OK to not set default value for AWS Credentials so AWS can use Roles and internally set AWS credentials
- Added `context.json` so it can easily be overwritten
- Allow using a custom (and passed through) `event.json` file
- Added `package` command for easy zip creation and inspection
- Added `VpcConfig` support, see [this PR](https://github.com/motdotla/node-lambda/pull/64) for more information
- Updated the AWS API version used to `2015-03-31`
- Make sure we throw errors on unrecoverable failures so other programs can listen on that
- Added support for nodejs4.3 runtime ([introducted to AWS](https://aws.amazon.com/blogs/compute/node-js-4-3-2-runtime-now-available-on-lambda/) Apr 7 2016)
- Added support for `post install scripts`, this `post_install.sh` file will be triggered after `npm install --production` in case you want to run any code on your application before zipping
- Added `-x` / `--excludeGlobs` to allow custom file exclusion
- Excluding `*.swp`, `deploy.env` by default now

## [0.8.1] - 2016-04-22
### Bugfixes
- Resolved a problem with excludes not being set [#91](https://github.com/motdotla/node-lambda/pull/91)
- Resolved a problem with the package command and a custom config file [#90](https://github.com/motdotla/node-lambda/pull/90)
- Allow `use strict` [#86](https://github.com/motdotla/node-lambda/pull/86)
- Updated the `env.example` file to set the default (and by AWS recommended) runtime to `nodejs4.3` [#84](https://github.com/motdotla/node-lambda/pull/84)

## [0.8.2] - 2016-05-12
### Bugfixes
- Verify env vars before creating sample files [#99](https://github.com/motdotla/node-lambda/pull/99)
- Fix `AWS_PUBLIS` typo [#102](https://github.com/motdotla/node-lambda/pull/102)
### Added
- Allow checking on `process.env.environment` to context switch [#95](https://github.com/motdotla/node-lambda/pull/95)

## [0.8.3] - 2016-05-12
### Bugfixes
- Added `EXCLUDE_GLOBS` to `package`, so your local ZIPs are the same as the ZIPs uploaded to AWS Lambda [#104](https://github.com/motdotla/node-lambda/pull/104)

## [0.8.4] - 2016-05-20
### Bugfixes
- Added extra quotes around the parsed environment [#106](https://github.com/motdotla/node-lambda/pull/106)

## [0.8.5] - 2016-05-27
### Adjustment
- Extremely verbose NPM installs could crash node-lambda's buffer [#108](https://github.com/motdotla/node-lambda/pull/108)

## [0.8.6] - 2016-06-28
### Feature
- Added `prebuiltDirectory` flag for users that want to use an already generated directory [#116](https://github.com/motdotla/node-lambda/pull/116)

### Bugfixes
- README was lying about how to use `excludeGlobs` [#111](https://github.com/motdotla/node-lambda/pull/111)

## [0.8.7] - 2016-08-16
### Features
- Added `-L` to rsync to allow copying of symlinks [#126](https://github.com/motdotla/node-lambda/pull/126)
- Added travisci support for node 6 [#129](https://github.com/motdotla/node-lambda/pull/129)
- Support to use package.json description for AWS description [#133](https://github.com/motdotla/node-lambda/pull/133)
- Inject environment variables via config file for the `run` command [#136](https://github.com/motdotla/node-lambda/pull/136)

### Bugfixes
- rsync should not exclude node_modules when using --prebuiltDirectory. [#122](https://github.com/motdotla/node-lambda/pull/122)
- Set environment variables _before_ requiring module [#137](https://github.com/motdotla/node-lambda/pull/137)
- Typo fix publish when updating existing function [#138](https://github.com/motdotla/node-lambda/pull/138)

## [0.8.8] - 2016-09-02
### Features
- Support AWS_PROFILE and de-duped a few CLI options [#144](https://github.com/motdotla/node-lambda/pull/144)
- `wrench` was deprecated and has been replaced by `fs-extra` [#146](https://github.com/motdotla/node-lambda/pull/146)

### Bugs
- Displaying `node-lambda -h` returned an error [#127](https://github.com/motdotla/node-lambda/issues/127)
- NPM overwrites `$TMPDIR` [#134](https://github.com/motdotla/node-lambda/issues/134)

## [0.8.9] - 2016-09-06
### Bugs
- The above mentioned fix for issue [#127](https://github.com/motdotla/node-lambda/issues/127) exposed a commander bug, reverted the change
- Do not exclude package.json, even when specified in excludeGlobs [#141](https://github.com/motdotla/node-lambda/pull/141)

## [0.8.10] - 2016-09-20
### Features
- We are now passing the environment string to the post install script [#154](https://github.com/motdotla/node-lambda/pull/154)

## [0.8.11] - 2016-10-28
### Bugfixes
- Restore lambda version functionality [#156](https://github.com/motdotla/node-lambda/issues/156)
- Namespaced packages fail to deploy [#157](https://github.com/motdotla/node-lambda/issues/157)

## [0.8.12] - 2017-02-10
### Bugfixes
- Using path.join instead of hardcoded slashes [#173](https://github.com/motdotla/node-lambda/pull/173)
- Drop node-uuid from package.json [#174](https://github.com/motdotla/node-lambda/pull/174)
- Enforce max for timeout and update README docs [#180](https://github.com/motdotla/node-lambda/pull/180)
- Fill default VpcConfig to prevent errors [#183](https://github.com/motdotla/node-lambda/pull/183)

### Features
- Added getRemainingTimeInMillis() to the context when running locally. [#179](https://github.com/motdotla/node-lambda/pull/179)
- Adding support for lambda environment variables [#181](https://github.com/motdotla/node-lambda/pull/181)

## [0.8.13] - 2017-02-12
### Bugfixes
- Fixed wrong runtime call [#188](https://github.com/motdotla/node-lambda/pull/188)
- Docker support [#186](https://github.com/motdotla/node-lambda/pull/186)
- Make default excludes apply to root only [#185](https://github.com/motdotla/node-lambda/pull/185)


## [0.8.14] - 2017-03-27
### Features
- Event source mapping support [#189](https://github.com/motdotla/node-lambda/pull/189)
- Fix version of Node.js supported by AWS Lambda [#197](https://github.com/motdotla/node-lambda/pull/197)
- How about it if you have the option to specify the zip file? [#199](https://github.com/motdotla/node-lambda/pull/199)
- Add 'Runtime' to the params of lambda.updateFunctionConfiguration [#200](https://github.com/motdotla/node-lambda/pull/200)

### Bugfixes
- Fix unit test failure at travis [#198](https://github.com/motdotla/node-lambda/pull/198)

## [0.8.15] - 2017-03-28
### Features
- Added DeadLetterConfig parameter [#206](https://github.com/motdotla/node-lambda/pull/206)

### Bugfixes
- Fix default value of EVENT_SOURCE_FILE set '' [#205](https://github.com/motdotla/node-lambda/pull/205)
- Removed event_sources.json [#204](https://github.com/motdotla/node-lambda/pull/204)
- Add -S, --eventSourceFile option. [#203](https://github.com/motdotla/node-lambda/pull/203)

## [0.9.0] - 2017-04-13
### Features
- Add tests for _readArchive [#213](https://github.com/motdotla/node-lambda/pull/213)
- Add tests for event_sources.json [#214](https://github.com/motdotla/node-lambda/pull/214)
- Add tests for DeadLetterConfig [#215](https://github.com/motdotla/node-lambda/pull/215)
- Add _readArchive tests called in _archive [#216](https://github.com/motdotla/node-lambda/pull/216)
- modify badge from png to svg [#227](https://github.com/motdotla/node-lambda/pull/227)
- ScheduleEvents [#228](https://github.com/motdotla/node-lambda/pull/228)

### Bugfixes
- Bugfix InvalidParameterValueException is given when createFunction [#209](https://github.com/motdotla/node-lambda/pull/209)
- Clean unnecessary `else` [#217](https://github.com/motdotla/node-lambda/pull/217)
- Refactor _eventSourceList [#218](https://github.com/motdotla/node-lambda/pull/218)
- Clean deploy function [#220](https://github.com/motdotla/node-lambda/pull/220)
- Fix default value of params.Environment.Variables is null [#221](https://github.com/motdotla/node-lambda/pull/221)
- Fix to use authenticated `aws` object in main.js [#225](https://github.com/motdotla/node-lambda/pull/225)
- Changed the format of `event_sources.json` [#226](https://github.com/motdotla/node-lambda/pull/226)

## [0.10.0] - 2017-05-10
### Features
- Fix use fs object [#236](https://github.com/motdotla/node-lambda/pull/236)
- Upgrade lodash [#237](https://github.com/motdotla/node-lambda/pull/237)
- Add file copy function without rsync command [#238](https://github.com/motdotla/node-lambda/pull/238)
- Add node.js 7 to `travis.yml` [#239](https://github.com/motdotla/node-lambda/pull/239)
- Set http timeout to 30 mins. [#240](https://github.com/motdotla/node-lambda/pull/240)
- Supported `TracingConfig` [#243](https://github.com/motdotla/node-lambda/pull/243)
- Fix to using `path` object [#249](https://github.com/motdotla/node-lambda/pull/249)
- Allow use of docker container for npm install [#251](https://github.com/motdotla/node-lambda/pull/251)
- Bugfix `_filecopy` exclude [#253](https://github.com/motdotla/node-lambda/pull/253)
- Fix to replace `_rsync` with `_fileCopy` [#254](https://github.com/motdotla/node-lambda/pull/254)
- Custom ScheduleEvent rule description [#257](https://github.com/motdotla/node-lambda/pull/257)
- Add test `functionName` pattern [#263](https://github.com/motdotla/node-lambda/pull/263)
- Added `- cwd` option to `npm install` command [#265](https://github.com/motdotla/node-lambda/pull/265)

### Bugfixes
- Add an overview of `event_sources.json` [#230](https://github.com/motdotla/node-lambda/pull/230)
- Cleanup of `main.js run` [#231](https://github.com/motdotla/node-lambda/pull/231)
- Fix results outputs [#233](https://github.com/motdotla/node-lambda/pull/233)
- Bugfix for backward compatible objects [#234](https://github.com/motdotla/node-lambda/pull/234)
- Fix after process of tests [#235](https://github.com/motdotla/node-lambda/pull/235)
- Fix to be the same specification as `--exclude` of rsync command (about function which is an alternative to rsync command) [#244](https://github.com/motdotla/node-lambda/pull/244)
- Fix to avoid `commander` bug [#247](https://github.com/motdotla/node-lambda/pull/247)
- Fix `fs.exists` deprecated [#250](https://github.com/motdotla/node-lambda/pull/250)
- Fix using `assert.include` [#252](https://github.com/motdotla/node-lambda/pull/252)
- Fix not doing anything if `event_sources.json` is not specified [#256](https://github.com/motdotla/node-lambda/pull/256)
- Fix using `path` [#258](https://github.com/motdotla/node-lambda/pull/258)
- Fix tests for windows [#259](https://github.com/motdotla/node-lambda/pull/259)
- Add Command Prompt to README [#266](https://github.com/motdotla/node-lambda/pull/266)
- Fix indexjs current style [#268](https://github.com/motdotla/node-lambda/pull/268)
- Fixed typo - Labmda => Lambda [#269](https://github.com/motdotla/node-lambda/pull/269)
- Fix not to create `.env` sample file with `_buildAndArchive` [#270](https://github.com/motdotla/node-lambda/pull/270)
